efficiency, don't apt update again if already done

This commit is contained in:
Jeffrey Paul 2025-03-29 00:30:17 -07:00
parent 2707542a45
commit ee188a30d7

View File

@ -2,6 +2,10 @@
set -euo pipefail set -euo pipefail
function apt_update_if_stale () {
[ -z "$(find /var/lib/apt/lists -type f -mmin -30 2>/dev/null)" ] && apt-get update
}
function main () { function main () {
# check for ubuntu only # check for ubuntu only
if ! grep -qi '^ID=ubuntu' /etc/os-release; then if ! grep -qi '^ID=ubuntu' /etc/os-release; then
@ -25,34 +29,25 @@ function main () {
find /etc/apt/sources.list.d/ -type f -exec \ find /etc/apt/sources.list.d/ -type f -exec \
sed -i "s|archive\.ubuntu\.com|us.ubuntu.com|g" {} + sed -i "s|archive\.ubuntu\.com|us.ubuntu.com|g" {} +
apt_update_if_stale
UPDATED=0 apt install -y jq curl
if ! which jq > /dev/null; then
echo "jq not found, installing..." > /dev/stderr
if [[ "$UPDATED" -eq 0 ]]; then
apt update
UPDATED=1
fi
apt install -y jq
fi
if ! which curl > /dev/null; then
echo "curl not found, installing..." > /dev/stderr
if [ "$UPDATED" -eq 0 ]; then
apt update
UPDATED=1
fi
apt install -y curl
fi
echo "Detecting actual country..." > /dev/stderr echo "Detecting actual country..." > /dev/stderr
IPINFO="$(curl -s ipinfo.io)" IPINFO="$(curl -s ipinfo.io)"
if [ -z "$IPINFO" ]; then if [ -z "$IPINFO" ]; then
echo "Failed to get IP info" > /dev/stderr echo "Failed to get IP info" > /dev/stderr
exit 1 exit 1
fi fi
COUNTRYCODE="$(jq .country -r <<< "$IPINFO")" COUNTRYCODE="$(jq .country -r <<< "$IPINFO")"
if [[ -z "$COUNTRYCODE" ]]; then
echo "Failed to get country code" > /dev/stderr
exit 1
fi
echo "IP geolocated as country: $COUNTRYCODE" > /dev/stderr echo "IP geolocated as country: $COUNTRYCODE" > /dev/stderr
if ! grep -qE 'http(s)?://us\.archive\.ubuntu\.com/' /etc/apt/sources.list.d/*; then if ! grep -qE 'http(s)?://us\.archive\.ubuntu\.com/' /etc/apt/sources.list.d/*; then